import '../models/point.dart';
import '../platform_interface/client.dart';
import '../utils/mappings.dart';
import 'method_channel_client.dart';

mixin MethodChannelPointClient on RKZClientPlatform
    implements MethodChannelClientInterface {
  @override
  Future<Point> getPoint(String userAccessToken) async {
    final data = await channel.invokeMapMethod<String, dynamic>(
        'getPoint', {'userAccessToken': userAccessToken});
    return Point.fromMap(data!);
  }

  @override
  Future<Point> addPoint(String userAccessToken, int point,
      {DateTime? addedDate}) async {
    final data = await channel.invokeMapMethod<String, dynamic>('addPoint', {
      'userAccessToken': userAccessToken,
      'point': point,
      'addedDate': exportDate(addedDate)
    });
    return Point.fromMap(data!);
  }
}
