import '../utils/mappings.dart';
import 'attributable.dart';

/// アプリケーション設定情報。
class AppSettings with Attributable {
  /// アプリ公開終了日付
  DateTime? appEndDte;

  /// アプリ公開終了フラグ
  bool? appEndFlg;

  /// アプリ公開終了メッセージ
  String? appEndMessage;

  /// AppStoreのURL
  String? appStoreUrl;

  /// コード
  String? code;

  /// GooglePlayのURL
  String? googlePlayStoreUrl;

  /// アプリ名称
  String? name;

  /// 使用不可フラグ
  bool? notUseFlg;

  /// 短縮名称
  String? shortName;

  /// 順序
  int? sortNo;

  /// アプリバージョン(Android)
  String? versionAndroid;

  /// アプリバージョン(iOS)
  String? versionIos;

  AppSettings();

  factory AppSettings.fromMap(Map<String, dynamic> map) {
    final data = AppSettings();

    data.appEndDte = importDate(map['appEndDte'] as int?);
    data.appEndFlg = map['appEndFlg'] as bool?;
    data.appEndMessage = map['appEndMessage'] as String?;
    data.appStoreUrl = map['appStoreUrl'] as String?;
    data.code = map['code'] as String?;
    data.googlePlayStoreUrl = map['googlePlayStoreUrl'] as String?;
    data.name = map['name'] as String?;
    data.notUseFlg = map['notUseFlg'] as bool?;
    data.shortName = map['shortName'] as String?;
    data.sortNo = map['sortNo'] as int?;
    data.versionAndroid = map['versionAndroid'] as String?;
    data.versionIos = map['versionIos'] as String?;
    data.attributes = importMap(map['attributes'] as Map?);

    return data;
  }

  Map<String, dynamic> toMap() {
    final map = <String, dynamic>{};

    map['appEndDte'] = exportDate(appEndDte);
    map['appEndFlg'] = appEndFlg;
    map['appEndMessage'] = appEndMessage;
    map['appStoreUrl'] = appStoreUrl;
    map['code'] = code;
    map['googlePlayStoreUrl'] = googlePlayStoreUrl;
    map['name'] = name;
    map['notUseFlg'] = notUseFlg;
    map['shortName'] = shortName;
    map['sortNo'] = sortNo;
    map['versionAndroid'] = versionAndroid;
    map['versionIos'] = versionIos;
    map['attributes'] = exportAttributes(attributes);

    return map;
  }
}
