import '../utils/mappings.dart';
import 'attributable.dart';

/// ビーコン情報オブジェクト。
class Beacon with Attributable {
  /// ビーコンID
  String? beaconId;

  /// ビーコンタイプコード
  String? beaconTypeCd;

  /// コード
  String? code;

  /// major
  int? major;

  /// minor
  int? minor;

  /// ビーコン端末名称
  String? name;

  /// 使用不可フラグ
  bool? notUseFlg;

  /// 短縮名称
  String? shortName;

  /// 順序
  int? sortNo;

  Beacon();

  factory Beacon.fromMap(Map<String, dynamic> map) {
    final data = Beacon();

    data.beaconId = map['beaconId'] as String?;
    data.beaconTypeCd = map['beaconTypeCd'] as String?;
    data.code = map['code'] as String?;
    data.major = map['major'] as int?;
    data.minor = map['minor'] as int?;
    data.name = map['name'] as String?;
    data.notUseFlg = map['notUseFlg'] as bool?;
    data.shortName = map['shortName'] as String?;
    data.sortNo = map['sortNo'] as int?;
    data.attributes = importMap(map['attributes'] as Map?);

    return data;
  }

  Map<String, dynamic> toMap() {
    final map = <String, dynamic>{};

    map['beaconId'] = beaconId;
    map['beaconTypeCd'] = beaconTypeCd;
    map['code'] = code;
    map['major'] = major;
    map['minor'] = minor;
    map['name'] = name;
    map['notUseFlg'] = notUseFlg;
    map['shortName'] = shortName;
    map['sortNo'] = sortNo;
    map['attributes'] = exportAttributes(attributes);

    return map;
  }
}
