import '../utils/mappings.dart';

/// 追加するビーコン検知コンタクト情報
class BeaconDetectContact {
  /// ビーコンID
  String? beaconId;

  /// ビーコンスポットコード
  String? beaconSpotCd;

  /// コンタクト種別名称
  String? contactClassCdName;

  /// コンタクト種別コード
  String? contactClassCd;

  /// 日時
  DateTime? contactDate;

  /// コンタクト方法種別名称
  String? contactMethodClassCdName;

  /// コンタクト方法種別コード
  String? contactMethodClassCd;

  /// コンタクト番号
  String? contactNo;

  /// 備考
  String? remarks;

  /// 受信電波強度
  int? rssi;

  /// 対象テナントID
  String? targetTenantId;

  /// ユーザーID
  String? userId;

  BeaconDetectContact();

  factory BeaconDetectContact.fromMap(Map<String, dynamic> map) {
    final data = BeaconDetectContact();

    data.beaconId = map['beaconId'] as String?;
    data.beaconSpotCd = map['beaconSpotCd'] as String?;
    data.contactClassCdName = map['contactClassCdName'] as String?;
    data.contactClassCd = map['contactClassCd'] as String?;
    data.contactDate = importDate(map['contactDate'] as int?);
    data.contactMethodClassCdName = map['contactMethodClassCdName'] as String?;
    data.contactMethodClassCd = map['contactMethodClassCd'] as String?;
    data.contactNo = map['contactNo'] as String?;
    data.remarks = map['remarks'] as String?;
    data.rssi = map['rssi'] as int?;
    data.targetTenantId = map['targetTenantId'] as String?;
    data.userId = map['userId'] as String?;

    return data;
  }

  Map<String, dynamic> toMap() {
    final map = <String, dynamic>{};

    map['beaconId'] = beaconId;
    map['beaconSpotCd'] = beaconSpotCd;
    map['contactClassCdName'] = contactClassCdName;
    map['contactClassCd'] = contactClassCd;
    map['contactDate'] = exportDate(contactDate);
    map['contactMethodClassCdName'] = contactMethodClassCdName;
    map['contactMethodClassCd'] = contactMethodClassCd;
    map['contactNo'] = contactNo;
    map['remarks'] = remarks;
    map['rssi'] = rssi;
    map['targetTenantId'] = targetTenantId;
    map['userId'] = userId;

    return map;
  }
}
