import '../utils/mappings.dart';
import 'attributable.dart';

/// コンタクト情報。
class Contact with Attributable {
  /// ビーコンID
  String? beaconId;

  /// ビーコンスポットコード
  String? beaconSpotCd;

  /// コンタクト種別
  String? contactClassCd;

  /// 日時
  DateTime? contactDate;

  /// イベント名称
  String? contactItemName;

  /// イベント番号
  String? contactItemNo;

  /// コンタクト方法種別
  String? contactMethodClassCd;

  /// コンタクト番号
  String? contactNo;

  /// クーポンコード
  String? couponCd;

  /// 入金番号
  String? depositNo;

  /// 申込番号
  String? entryNo;

  /// 場所
  String? placeCd;

  /// ポイント数
  int? point;

  /// 数量
  int? quantity;

  /// 備考
  String? remarks;

  /// 受信電波強度
  int? rssi;

  /// スタンプラリーコード
  String? stampRallyCd;

  /// スタンプラリースポットコード
  String? stampRallySpotCd;

  /// 状態
  String? statusCd;

  Contact();

  factory Contact.fromMap(Map<String, dynamic> map) {
    final data = Contact();

    data.beaconId = map['beaconId'] as String?;
    data.beaconSpotCd = map['beaconSpotCd'] as String?;
    data.contactClassCd = map['contactClassCd'] as String?;
    data.contactDate = importDate(map['contactDate'] as int?);
    data.contactItemName = map['contactItemName'] as String?;
    data.contactItemNo = map['contactItemNo'] as String?;
    data.contactMethodClassCd = map['contactMethodClassCd'] as String?;
    data.contactNo = map['contactNo'] as String?;
    data.couponCd = map['couponCd'] as String?;
    data.depositNo = map['depositNo'] as String?;
    data.entryNo = map['entryNo'] as String?;
    data.placeCd = map['placeCd'] as String?;
    data.point = map['point'] as int?;
    data.quantity = map['quantity'] as int?;
    data.remarks = map['remarks'] as String?;
    data.rssi = map['rssi'] as int?;
    data.stampRallyCd = map['stampRallyCd'] as String?;
    data.stampRallySpotCd = map['stampRallySpotCd'] as String?;
    data.statusCd = map['statusCd'] as String?;
    data.attributes = importMap(map['attributes'] as Map?);

    return data;
  }

  Map<String, dynamic> toMap() {
    final map = <String, dynamic>{};

    map['beaconId'] = beaconId;
    map['beaconSpotCd'] = beaconSpotCd;
    map['contactClassCd'] = contactClassCd;
    map['contactDate'] = exportDate(contactDate);
    map['contactItemName'] = contactItemName;
    map['contactItemNo'] = contactItemNo;
    map['contactMethodClassCd'] = contactMethodClassCd;
    map['contactNo'] = contactNo;
    map['couponCd'] = couponCd;
    map['depositNo'] = depositNo;
    map['entryNo'] = entryNo;
    map['placeCd'] = placeCd;
    map['point'] = point;
    map['quantity'] = quantity;
    map['remarks'] = remarks;
    map['rssi'] = rssi;
    map['stampRallyCd'] = stampRallyCd;
    map['stampRallySpotCd'] = stampRallySpotCd;
    map['statusCd'] = statusCd;
    map['attributes'] = exportAttributes(attributes);

    return map;
  }
}
