import '../utils/mappings.dart';
import 'data.dart';

/// データオブジェクトの検索結果です。
class DataResult {
  /// 検索結果の件数
  ///
  /// [Query.offset]、[Query.limit]に設定した条件を含まない、検索結果の総件数が設定されます。
  late int resultCnt;

  /// データオブジェクト
  late List<Data> data;

  DataResult({required this.data, required this.resultCnt});

  factory DataResult.fromMap(Map<String, dynamic> map) {
    return DataResult(
        data: List<Map>.from(map['datas'] as List<dynamic>)
            .map(importMap)
            .map((data) => Data.fromMap(data!))
            .toList(),
        resultCnt: map['resultCnt'] as int? ?? 0);
  }
}
