import '../utils/mappings.dart';

/// お気に入り情報
class Favorite {
  /// お気に入り更新日時
  DateTime? favoriteDate;

  /// ユーザー自身がお気に入り登録している場合`true`
  bool? isFavorite;

  Favorite();

  factory Favorite.fromMap(Map<String, dynamic> map) {
    final data = Favorite();

    data.favoriteDate = importDate(map['favoriteDate'] as int?);
    data.isFavorite = map['isFavorite'] as bool?;

    return data;
  }

  static Favorite? import(Map<String, dynamic>? map) {
    if (map == null) return null;
    return Favorite.fromMap(map);
  }

  Map<String, dynamic> toMap() {
    final map = <String, dynamic>{};

    map['favoriteDate'] = exportDate(favoriteDate);
    map['isFavorite'] = isFavorite;

    return map;
  }
}
