import '../utils/mappings.dart';
import 'attributable.dart';

/// ロケール情報。
class Locale with Attributable {
  /// コード
  String? code;

  /// 初期選択フラグ
  bool? defaultFlg;

  /// 言語
  String? languageCd;

  /// 言語名称
  String? languageName;

  /// ロケール
  ///
  /// [Locale.languageCd]と同じ値が設定されます
  String? locale;

  /// 名称
  String? name;

  /// 使用不可フラグ
  bool? notUseFlg;

  /// 順序
  int? sortNo;

  Locale();

  factory Locale.fromMap(Map<String, dynamic> map) {
    final data = Locale();

    data.code = map['code'] as String?;
    data.defaultFlg = map['defaultFlg'] as bool?;
    data.languageCd = map['languageCd'] as String?;
    data.languageName = map['languageName'] as String?;
    data.locale = map['locale'] as String?;
    data.name = map['name'] as String?;
    data.notUseFlg = map['notUseFlg'] as bool?;
    data.sortNo = map['sortNo'] as int?;
    data.attributes = importMap(map['attributes'] as Map?);

    return data;
  }

  Map<String, dynamic> toMap() {
    final map = <String, dynamic>{};

    map['code'] = code;
    map['defaultFlg'] = defaultFlg;
    map['languageCd'] = languageCd;
    map['languageName'] = languageName;
    map['locale'] = locale;
    map['name'] = name;
    map['notUseFlg'] = notUseFlg;
    map['sortNo'] = sortNo;
    map['attributes'] = exportAttributes(attributes);

    return map;
  }
}
