/// 検索条件の位置情報オブジェクト
///
/// [range]を指定すると、[latitude]と[longitude]を中心点とした半径内に該当するスポットを抽出します。
///
/// **NOTE:** [latitude]と[longitude]はどちらも指定する必要があります。
/// [range]を指定する場合は、[latitude]と[longitude]のどちらも指定しておく必要があります。
class RKZLocation {
  /// 検索する中心点の緯度
  double? latitude;

  /// 検索する中心点の経度
  double? longitude;

  /// 検索する中心点からの半径。単位はkm
  double? range;

  /// コンストラクタです。
  RKZLocation({this.latitude, this.longitude, this.range});

  factory RKZLocation.fromMap(Map<String, dynamic> map) {
    final data = RKZLocation();

    data.latitude = map['latitude'] as double?;
    data.longitude = map['longitude'] as double?;
    data.range = map['range'] as double?;

    return data;
  }

  Map<String, dynamic> toMap() {
    final map = <String, dynamic>{};

    map['latitude'] = latitude;
    map['longitude'] = longitude;
    map['range'] = range;

    return map;
  }
}
