import '../utils/mappings.dart';

/// 機種変更認証情報
class ModelChangeResult {
  /// 機種変更認証コード
  ///
  /// 発行された機種変更認証コードが設定されています。
  DateTime? limitDate;

  /// 認証認証コード有効期限
  ///
  /// 発行された機種変更認証コードの有効期限が設定されています。
  String? modelChangeCode;

  ModelChangeResult();

  factory ModelChangeResult.fromMap(Map<String, dynamic> map) {
    final data = ModelChangeResult();

    data.limitDate = importDate(map['limitDate'] as int?);
    data.modelChangeCode = map['modelChangeCode'] as String?;

    return data;
  }

  Map<String, dynamic> toMap() {
    final map = <String, dynamic>{};

    map['limitDate'] = exportDate(limitDate);
    map['modelChangeCode'] = modelChangeCode;

    return map;
  }
}
