import '../utils/mappings.dart';
import 'coupon.dart';

/// マイクーポン情報
class MyCoupon {
  /// コード
  String? code;

  /// クーポンコード
  String? couponCd;

  /// クーポン名称
  String? couponName;

  /// クーポン情報
  Coupon? coupon;

  /// クーポン発行日時
  DateTime? getDate;

  /// 数量
  int? quantity;

  /// クーポン使用済日時
  DateTime? useDate;

  /// クーポン使用済フラグ
  bool? usedFlg;

  /// ユーザーID
  String? userId;

  MyCoupon();

  factory MyCoupon.fromMap(Map<String, dynamic> map) {
    final data = MyCoupon();

    data.code = map['code'] as String?;
    data.couponCd = map['couponCd'] as String?;
    data.couponName = map['couponName'] as String?;
    data.coupon = Coupon.import(importMap(map['coupon'] as Map?));
    data.getDate = importDate(map['getDate'] as int?);
    data.quantity = map['quantity'] as int?;
    data.useDate = importDate(map['useDate'] as int?);
    data.usedFlg = map['usedFlg'] as bool?;
    data.userId = map['userId'] as String?;

    return data;
  }

  Map<String, dynamic> toMap() {
    final map = <String, dynamic>{};

    map['code'] = code;
    map['couponCd'] = couponCd;
    map['couponName'] = couponName;
    map['coupon'] = coupon?.toMap();
    map['getDate'] = exportDate(getDate);
    map['quantity'] = quantity;
    map['useDate'] = exportDate(useDate);
    map['usedFlg'] = usedFlg;
    map['userId'] = userId;

    return map;
  }
}
