import '../utils/mappings.dart';
import 'news.dart';

/// お知らせ情報の検索結果です。
class NewsResult {
  /// 検索結果の件数
  late int resultCnt;

  /// お知らせ情報
  late List<News> data;

  /// コンストラクタです。
  NewsResult({required this.data, required this.resultCnt});

  factory NewsResult.fromMap(Map<String, dynamic> map) {
    return NewsResult(
        data: List<Map>.from(map['datas'] as List<dynamic>)
            .map(importMap)
            .map((data) => News.fromMap(data!))
            .toList(),
        resultCnt: map['resultCnt'] as int? ?? 0);
  }
}
