import '../utils/mappings.dart';
import 'attributable.dart';

/// スタンプ履歴情報。
class StampHistory with Attributable {
  /// コンタクト種別
  String? contactClassCd;

  /// コンタクト日時
  DateTime? contactDate;

  /// スタンプラリーコード
  String? stampRallyCd;

  /// スタンプラリー名称
  String? stampRallyName;

  /// スタンプラリースポットコード
  String? stampRallySpotCd;

  /// スタンプラリースポット名称
  String? stampRallySpotName;

  StampHistory();

  factory StampHistory.fromMap(Map<String, dynamic> map) {
    final data = StampHistory();

    data.contactClassCd = map['contactClassCd'] as String?;
    data.contactDate = importDate(map['contactDate'] as int?);
    data.stampRallyCd = map['stampRallyCd'] as String?;
    data.stampRallyName = map['stampRallyName'] as String?;
    data.stampRallySpotCd = map['stampRallySpotCd'] as String?;
    data.stampRallySpotName = map['stampRallySpotName'] as String?;
    data.attributes = importMap(map['attributes'] as Map?);

    return data;
  }

  Map<String, dynamic> toMap() {
    final map = <String, dynamic>{};

    map['contactClassCd'] = contactClassCd;
    map['contactDate'] = exportDate(contactDate);
    map['stampRallyCd'] = stampRallyCd;
    map['stampRallyName'] = stampRallyName;
    map['stampRallySpotCd'] = stampRallySpotCd;
    map['stampRallySpotName'] = stampRallySpotName;
    map['attributes'] = exportAttributes(attributes);

    return map;
  }
}
