import '../utils/mappings.dart';
import 'attributable.dart';

/// スタンプラリー情報。
class StampRally with Attributable {
  /// コード
  String? code;

  /// コンプリート条件コード
  String? completeConditionCd;

  /// コンプリート条件名称
  String? completeConditionName;

  /// コンプリート可能回数コード
  String? completeCountCd;

  /// コンプリート可能回数名称
  String? completeCountName;

  /// スタンプラリー名称
  String? name;

  /// 使用不可フラグ
  bool? notUseFlg;

  /// 短縮名称
  String? shortName;

  /// 順序
  int? sortNo;

  /// スタンプ有効期限コード
  String? stampExpirationDateCd;

  /// スタンプ有効期限名称
  String? stampExpirationDateName;

  /// スタンプラリー詳細
  String? stampRallyDetail;

  /// スタンプラリー開催終了日
  DateTime? stampRallyEndDate;

  /// スタンプラリー画像URL
  String? stampRallyImageUrl;

  /// スタンプラリー画像
  String? stampRallyImage;

  /// スタンプラリー開催開始日
  DateTime? stampRallyStartDate;

  StampRally();

  factory StampRally.fromMap(Map<String, dynamic> map) {
    final data = StampRally();

    data.code = map['code'] as String?;
    data.completeConditionCd = map['completeConditionCd'] as String?;
    data.completeConditionName = map['completeConditionName'] as String?;
    data.completeCountCd = map['completeCountCd'] as String?;
    data.completeCountName = map['completeCountName'] as String?;
    data.name = map['name'] as String?;
    data.notUseFlg = map['notUseFlg'] as bool?;
    data.shortName = map['shortName'] as String?;
    data.sortNo = map['sortNo'] as int?;
    data.stampExpirationDateCd = map['stampExpirationDateCd'] as String?;
    data.stampExpirationDateName = map['stampExpirationDateName'] as String?;
    data.stampRallyDetail = map['stampRallyDetail'] as String?;
    data.stampRallyEndDate = importDate(map['stampRallyEndDate'] as int?);
    data.stampRallyImageUrl = map['stampRallyImageUrl'] as String?;
    data.stampRallyImage = map['stampRallyImage'] as String?;
    data.stampRallyStartDate = importDate(map['stampRallyStartDate'] as int?);
    data.attributes = importMap(map['attributes'] as Map?);

    return data;
  }

  Map<String, dynamic> toMap() {
    final map = <String, dynamic>{};

    map['code'] = code;
    map['completeConditionCd'] = completeConditionCd;
    map['completeConditionName'] = completeConditionName;
    map['completeCountCd'] = completeCountCd;
    map['completeCountName'] = completeCountName;
    map['name'] = name;
    map['notUseFlg'] = notUseFlg;
    map['shortName'] = shortName;
    map['sortNo'] = sortNo;
    map['stampExpirationDateCd'] = stampExpirationDateCd;
    map['stampExpirationDateName'] = stampExpirationDateName;
    map['stampRallyDetail'] = stampRallyDetail;
    map['stampRallyEndDate'] = exportDate(stampRallyEndDate);
    map['stampRallyImageUrl'] = stampRallyImageUrl;
    map['stampRallyImage'] = stampRallyImage;
    map['stampRallyStartDate'] = exportDate(stampRallyStartDate);
    map['attributes'] = exportAttributes(attributes);

    return map;
  }
}
