import '../utils/mappings.dart';
import 'attributable.dart';
import 'spot.dart';

/// スタンプラリースポット情報。
class StampRallySpot with Attributable {
  /// コード
  String? code;

  /// 名称
  String? name;

  /// 使用不可フラグ
  bool? notUseFlg;

  /// 順序
  int? sortNo;

  /// スポット
  Spot? spot;

  /// スタンプラリーコード
  String? stampRallyCd;

  /// スタンプラリー名称
  String? stampRallyName;

  StampRallySpot();

  factory StampRallySpot.fromMap(Map<String, dynamic> map) {
    final data = StampRallySpot();

    data.code = map['code'] as String?;
    data.name = map['name'] as String?;
    data.notUseFlg = map['notUseFlg'] as bool?;
    data.sortNo = map['sortNo'] as int?;
    data.spot = Spot.import(importMap(map['spot'] as Map?));
    data.stampRallyCd = map['stampRallyCd'] as String?;
    data.stampRallyName = map['stampRallyName'] as String?;
    data.attributes = importMap(map['attributes'] as Map?);

    return data;
  }

  Map<String, dynamic> toMap() {
    final map = <String, dynamic>{};

    map['code'] = code;
    map['name'] = name;
    map['notUseFlg'] = notUseFlg;
    map['sortNo'] = sortNo;
    map['spot'] = spot?.toMap();
    map['stampRallyCd'] = stampRallyCd;
    map['stampRallyName'] = stampRallyName;
    map['attributes'] = exportAttributes(attributes);

    return map;
  }
}
