import '../utils/mappings.dart';
import 'attributable.dart';

/// ユーザー情報。
class User with Attributable {
  /// 年代
  String? ageConfig;

  /// 生年月日
  DateTime? birthDay;

  /// 職業
  String? businessClassCd;

  /// 登録日
  DateTime? joinDte;

  /// 最終更新日時
  DateTime? lastUpdateDte;

  /// ログインID
  String? loginId;

  /// ワンタイムパスワードフラグ
  bool? onetimePassFlg;

  /// ポイント数
  int? point;

  /// 性別
  String? sexCd;

  /// 都道府県
  String? stateCd;

  /// ユーザーアクセストークン
  String? userAccessToken;

  /// メイ
  String? userFirstFurigana;

  /// 名
  String? userFirstName;

  /// 氏名（フリガナ）
  String? userFurigana;

  /// ユーザーID
  String? userId;

  /// セイ
  String? userLastFurigana;

  /// 姓
  String? userLastName;

  /// 氏名
  String? userName;

  /// 顧客番号
  String? userNo;

  User();

  factory User.fromMap(Map<String, dynamic> map) {
    final data = User();

    data.ageConfig = map['ageConfig'] as String?;
    data.birthDay = importDate(map['birthDay'] as int?);
    data.businessClassCd = map['businessClassCd'] as String?;
    data.joinDte = importDate(map['joinDte'] as int?);
    data.lastUpdateDte = importDate(map['lastUpdateDte'] as int?);
    data.loginId = map['loginId'] as String?;
    data.onetimePassFlg = map['onetimePassFlg'] as bool?;
    data.point = map['point'] as int?;
    data.sexCd = map['sexCd'] as String?;
    data.stateCd = map['stateCd'] as String?;
    data.userAccessToken = map['userAccessToken'] as String?;
    data.userFirstFurigana = map['userFirstFurigana'] as String?;
    data.userFirstName = map['userFirstName'] as String?;
    data.userFurigana = map['userFurigana'] as String?;
    data.userId = map['userId'] as String?;
    data.userLastFurigana = map['userLastFurigana'] as String?;
    data.userLastName = map['userLastName'] as String?;
    data.userName = map['userName'] as String?;
    data.userNo = map['userNo'] as String?;
    data.attributes = importMap(map['attributes'] as Map?);

    return data;
  }

  Map<String, dynamic> toMap() {
    final map = <String, dynamic>{};

    map['ageConfig'] = ageConfig;
    map['birthDay'] = exportDate(birthDay);
    map['businessClassCd'] = businessClassCd;
    map['joinDte'] = exportDate(joinDte);
    map['lastUpdateDte'] = exportDate(lastUpdateDte);
    map['loginId'] = loginId;
    map['onetimePassFlg'] = onetimePassFlg;
    map['point'] = point;
    map['sexCd'] = sexCd;
    map['stateCd'] = stateCd;
    map['userAccessToken'] = userAccessToken;
    map['userFirstFurigana'] = userFirstFurigana;
    map['userFirstName'] = userFirstName;
    map['userFurigana'] = userFurigana;
    map['userId'] = userId;
    map['userLastFurigana'] = userLastFurigana;
    map['userLastName'] = userLastName;
    map['userName'] = userName;
    map['userNo'] = userNo;
    map['attributes'] = exportAttributes(attributes);

    return map;
  }
}
