import '../utils/mappings.dart';
import 'user_detail.dart';

/// ユーザー詳細の検索結果です。
class UserDetailResult {
  /// 検索結果の件数
  ///
  /// [Query.offset]、[Query.limit]に設定した条件を含まない、検索結果の総件数が設定されます。
  late int resultCnt;

  /// ユーザー詳細
  late List<UserDetail> data;

  /// コンストラクタです。
  UserDetailResult({required this.data, required this.resultCnt});

  factory UserDetailResult.fromMap(Map<String, dynamic> map) {
    return UserDetailResult(
        data: List<Map>.from(map['datas'] as List<dynamic>)
            .map(importMap)
            .map((data) => UserDetail.fromMap(data!))
            .toList(),
        resultCnt: map['resultCnt'] as int? ?? 0);
  }
}
