import 'package:plugin_platform_interface/plugin_platform_interface.dart';

abstract class QueryPlatform extends PlatformInterface {
  QueryPlatform() : super(token: _token);

  static final Object _token = Object();

  void equalTo(String columnName, String value) {
    throw UnimplementedError('equalTo() is not implemented');
  }

  void notEqualTo(String columnName, String value) {
    throw UnimplementedError('notEqualTo() is not implemented');
  }

  void containedIn(String columnName, List<String> values) {
    throw UnimplementedError('containedIn() is not implemented');
  }

  void notContainedIn(String columnName, List<String> values) {
    throw UnimplementedError('notContainedIn() is not implemented');
  }

  void lessThanOrEqualTo(String columnName, String value) {
    throw UnimplementedError('lessThanOrEqualTo() is not implemented');
  }

  void greaterThanOrEqualTo(String columnName, String value) {
    throw UnimplementedError('greaterThanOrEqualTo() is not implemented');
  }

  void betweenInclude(String columnName, String from, String to) {
    throw UnimplementedError('betweenInclude() is not implemented');
  }

  void betweenExclude(String columnName, String from, String to) {
    throw UnimplementedError('betweenExclude() is not implemented');
  }

  void startsWith(String columnName, String value) {
    throw UnimplementedError('startsWith() is not implemented');
  }

  void endsWith(String columnName, String value) {
    throw UnimplementedError('endsWith() is not implemented');
  }

  void contains(String columnName, String value) {
    throw UnimplementedError('contains() is not implemented');
  }

  void containsInArray(String columnName, List<String> values) {
    throw UnimplementedError('containsInArray() is not implemented');
  }

  void asc(String columnName) {
    throw UnimplementedError('asc() is not implemented');
  }

  void desc(String columnName) {
    throw UnimplementedError('desc() is not implemented');
  }

  int? get offset {
    throw UnimplementedError('get offset() is not implemented');
  }

  set offset(int? offset) {
    throw UnimplementedError('set offset() is not implemented');
  }

  int? get limit {
    throw UnimplementedError('get limit() is not implemented');
  }

  set limit(int? limit) {
    throw UnimplementedError('set limit() is not implemented');
  }
}
